(window["webpackJsonp"] = window["webpackJsonp"] || []).push([[7],{

/***/ 108:
/***/ (function(module, exports) {

module.exports = function escape(url) {
    if (typeof url !== 'string') {
        return url
    }
    // If url is already wrapped in quotes, remove them
    if (/^['"].*['"]$/.test(url)) {
        url = url.slice(1, -1);
    }
    // Should url be wrapped?
    // See https://drafts.csswg.org/css-values-3/#urls
    if (/["'() \t\n]/.test(url)) {
        return '"' + url.replace(/"/g, '\\"').replace(/\n/g, '\\n') + '"'
    }

    return url
}


/***/ }),

/***/ 16:
/***/ (function(module, exports) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
module.exports = function(useSourceMap) {
	var list = [];

	// return the list of modules as css string
	list.toString = function toString() {
		return this.map(function (item) {
			var content = cssWithMappingToString(item, useSourceMap);
			if(item[2]) {
				return "@media " + item[2] + "{" + content + "}";
			} else {
				return content;
			}
		}).join("");
	};

	// import a list of modules into the list
	list.i = function(modules, mediaQuery) {
		if(typeof modules === "string")
			modules = [[null, modules, ""]];
		var alreadyImportedModules = {};
		for(var i = 0; i < this.length; i++) {
			var id = this[i][0];
			if(typeof id === "number")
				alreadyImportedModules[id] = true;
		}
		for(i = 0; i < modules.length; i++) {
			var item = modules[i];
			// skip already imported module
			// this implementation is not 100% perfect for weird media query combinations
			//  when a module is imported multiple times with different media queries.
			//  I hope this will never occur (Hey this way we have smaller bundles)
			if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
				if(mediaQuery && !item[2]) {
					item[2] = mediaQuery;
				} else if(mediaQuery) {
					item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
				}
				list.push(item);
			}
		}
	};
	return list;
};

function cssWithMappingToString(item, useSourceMap) {
	var content = item[1] || '';
	var cssMapping = item[3];
	if (!cssMapping) {
		return content;
	}

	if (useSourceMap && typeof btoa === 'function') {
		var sourceMapping = toComment(cssMapping);
		var sourceURLs = cssMapping.sources.map(function (source) {
			return '/*# sourceURL=' + cssMapping.sourceRoot + source + ' */'
		});

		return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
	}

	return [content].join('\n');
}

// Adapted from convert-source-map (MIT)
function toComment(sourceMap) {
	// eslint-disable-next-line no-undef
	var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
	var data = 'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;

	return '/*# ' + data + ' */';
}


/***/ }),

/***/ 17:
/***/ (function(module, exports, __webpack_require__) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/

var stylesInDom = {};

var	memoize = function (fn) {
	var memo;

	return function () {
		if (typeof memo === "undefined") memo = fn.apply(this, arguments);
		return memo;
	};
};

var isOldIE = memoize(function () {
	// Test for IE <= 9 as proposed by Browserhacks
	// @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
	// Tests for existence of standard globals is to allow style-loader
	// to operate correctly into non-standard environments
	// @see https://github.com/webpack-contrib/style-loader/issues/177
	return window && document && document.all && !window.atob;
});

var getElement = (function (fn) {
	var memo = {};

	return function(selector) {
		if (typeof memo[selector] === "undefined") {
			var styleTarget = fn.call(this, selector);
			// Special case to return head of iframe instead of iframe itself
			if (styleTarget instanceof window.HTMLIFrameElement) {
				try {
					// This will throw an exception if access to iframe is blocked
					// due to cross-origin restrictions
					styleTarget = styleTarget.contentDocument.head;
				} catch(e) {
					styleTarget = null;
				}
			}
			memo[selector] = styleTarget;
		}
		return memo[selector]
	};
})(function (target) {
	return document.querySelector(target)
});

var singleton = null;
var	singletonCounter = 0;
var	stylesInsertedAtTop = [];

var	fixUrls = __webpack_require__(40);

module.exports = function(list, options) {
	if (typeof DEBUG !== "undefined" && DEBUG) {
		if (typeof document !== "object") throw new Error("The style-loader cannot be used in a non-browser environment");
	}

	options = options || {};

	options.attrs = typeof options.attrs === "object" ? options.attrs : {};

	// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
	// tags it will allow on a page
	if (!options.singleton && typeof options.singleton !== "boolean") options.singleton = isOldIE();

	// By default, add <style> tags to the <head> element
	if (!options.insertInto) options.insertInto = "head";

	// By default, add <style> tags to the bottom of the target
	if (!options.insertAt) options.insertAt = "bottom";

	var styles = listToStyles(list, options);

	addStylesToDom(styles, options);

	return function update (newList) {
		var mayRemove = [];

		for (var i = 0; i < styles.length; i++) {
			var item = styles[i];
			var domStyle = stylesInDom[item.id];

			domStyle.refs--;
			mayRemove.push(domStyle);
		}

		if(newList) {
			var newStyles = listToStyles(newList, options);
			addStylesToDom(newStyles, options);
		}

		for (var i = 0; i < mayRemove.length; i++) {
			var domStyle = mayRemove[i];

			if(domStyle.refs === 0) {
				for (var j = 0; j < domStyle.parts.length; j++) domStyle.parts[j]();

				delete stylesInDom[domStyle.id];
			}
		}
	};
};

function addStylesToDom (styles, options) {
	for (var i = 0; i < styles.length; i++) {
		var item = styles[i];
		var domStyle = stylesInDom[item.id];

		if(domStyle) {
			domStyle.refs++;

			for(var j = 0; j < domStyle.parts.length; j++) {
				domStyle.parts[j](item.parts[j]);
			}

			for(; j < item.parts.length; j++) {
				domStyle.parts.push(addStyle(item.parts[j], options));
			}
		} else {
			var parts = [];

			for(var j = 0; j < item.parts.length; j++) {
				parts.push(addStyle(item.parts[j], options));
			}

			stylesInDom[item.id] = {id: item.id, refs: 1, parts: parts};
		}
	}
}

function listToStyles (list, options) {
	var styles = [];
	var newStyles = {};

	for (var i = 0; i < list.length; i++) {
		var item = list[i];
		var id = options.base ? item[0] + options.base : item[0];
		var css = item[1];
		var media = item[2];
		var sourceMap = item[3];
		var part = {css: css, media: media, sourceMap: sourceMap};

		if(!newStyles[id]) styles.push(newStyles[id] = {id: id, parts: [part]});
		else newStyles[id].parts.push(part);
	}

	return styles;
}

function insertStyleElement (options, style) {
	var target = getElement(options.insertInto)

	if (!target) {
		throw new Error("Couldn't find a style target. This probably means that the value for the 'insertInto' parameter is invalid.");
	}

	var lastStyleElementInsertedAtTop = stylesInsertedAtTop[stylesInsertedAtTop.length - 1];

	if (options.insertAt === "top") {
		if (!lastStyleElementInsertedAtTop) {
			target.insertBefore(style, target.firstChild);
		} else if (lastStyleElementInsertedAtTop.nextSibling) {
			target.insertBefore(style, lastStyleElementInsertedAtTop.nextSibling);
		} else {
			target.appendChild(style);
		}
		stylesInsertedAtTop.push(style);
	} else if (options.insertAt === "bottom") {
		target.appendChild(style);
	} else if (typeof options.insertAt === "object" && options.insertAt.before) {
		var nextSibling = getElement(options.insertInto + " " + options.insertAt.before);
		target.insertBefore(style, nextSibling);
	} else {
		throw new Error("[Style Loader]\n\n Invalid value for parameter 'insertAt' ('options.insertAt') found.\n Must be 'top', 'bottom', or Object.\n (https://github.com/webpack-contrib/style-loader#insertat)\n");
	}
}

function removeStyleElement (style) {
	if (style.parentNode === null) return false;
	style.parentNode.removeChild(style);

	var idx = stylesInsertedAtTop.indexOf(style);
	if(idx >= 0) {
		stylesInsertedAtTop.splice(idx, 1);
	}
}

function createStyleElement (options) {
	var style = document.createElement("style");

	options.attrs.type = "text/css";

	addAttrs(style, options.attrs);
	insertStyleElement(options, style);

	return style;
}

function createLinkElement (options) {
	var link = document.createElement("link");

	options.attrs.type = "text/css";
	options.attrs.rel = "stylesheet";

	addAttrs(link, options.attrs);
	insertStyleElement(options, link);

	return link;
}

function addAttrs (el, attrs) {
	Object.keys(attrs).forEach(function (key) {
		el.setAttribute(key, attrs[key]);
	});
}

function addStyle (obj, options) {
	var style, update, remove, result;

	// If a transform function was defined, run it on the css
	if (options.transform && obj.css) {
	    result = options.transform(obj.css);

	    if (result) {
	    	// If transform returns a value, use that instead of the original css.
	    	// This allows running runtime transformations on the css.
	    	obj.css = result;
	    } else {
	    	// If the transform function returns a falsy value, don't add this css.
	    	// This allows conditional loading of css
	    	return function() {
	    		// noop
	    	};
	    }
	}

	if (options.singleton) {
		var styleIndex = singletonCounter++;

		style = singleton || (singleton = createStyleElement(options));

		update = applyToSingletonTag.bind(null, style, styleIndex, false);
		remove = applyToSingletonTag.bind(null, style, styleIndex, true);

	} else if (
		obj.sourceMap &&
		typeof URL === "function" &&
		typeof URL.createObjectURL === "function" &&
		typeof URL.revokeObjectURL === "function" &&
		typeof Blob === "function" &&
		typeof btoa === "function"
	) {
		style = createLinkElement(options);
		update = updateLink.bind(null, style, options);
		remove = function () {
			removeStyleElement(style);

			if(style.href) URL.revokeObjectURL(style.href);
		};
	} else {
		style = createStyleElement(options);
		update = applyToTag.bind(null, style);
		remove = function () {
			removeStyleElement(style);
		};
	}

	update(obj);

	return function updateStyle (newObj) {
		if (newObj) {
			if (
				newObj.css === obj.css &&
				newObj.media === obj.media &&
				newObj.sourceMap === obj.sourceMap
			) {
				return;
			}

			update(obj = newObj);
		} else {
			remove();
		}
	};
}

var replaceText = (function () {
	var textStore = [];

	return function (index, replacement) {
		textStore[index] = replacement;

		return textStore.filter(Boolean).join('\n');
	};
})();

function applyToSingletonTag (style, index, remove, obj) {
	var css = remove ? "" : obj.css;

	if (style.styleSheet) {
		style.styleSheet.cssText = replaceText(index, css);
	} else {
		var cssNode = document.createTextNode(css);
		var childNodes = style.childNodes;

		if (childNodes[index]) style.removeChild(childNodes[index]);

		if (childNodes.length) {
			style.insertBefore(cssNode, childNodes[index]);
		} else {
			style.appendChild(cssNode);
		}
	}
}

function applyToTag (style, obj) {
	var css = obj.css;
	var media = obj.media;

	if(media) {
		style.setAttribute("media", media)
	}

	if(style.styleSheet) {
		style.styleSheet.cssText = css;
	} else {
		while(style.firstChild) {
			style.removeChild(style.firstChild);
		}

		style.appendChild(document.createTextNode(css));
	}
}

function updateLink (link, options, obj) {
	var css = obj.css;
	var sourceMap = obj.sourceMap;

	/*
		If convertToAbsoluteUrls isn't defined, but sourcemaps are enabled
		and there is no publicPath defined then lets turn convertToAbsoluteUrls
		on by default.  Otherwise default to the convertToAbsoluteUrls option
		directly
	*/
	var autoFixUrls = options.convertToAbsoluteUrls === undefined && sourceMap;

	if (options.convertToAbsoluteUrls || autoFixUrls) {
		css = fixUrls(css);
	}

	if (sourceMap) {
		// http://stackoverflow.com/a/26603875
		css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */";
	}

	var blob = new Blob([css], { type: "text/css" });

	var oldSrc = link.href;

	link.href = URL.createObjectURL(blob);

	if(oldSrc) URL.revokeObjectURL(oldSrc);
}


/***/ }),

/***/ 1857:
/***/ (function(module, exports) {

/**
 * Tine 2.0
 * 
 * @package     Courses
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiss <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2007-2008 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 */
Ext.ns('Tine.Courses', 'Tine.Courses.Model');
/**
 * @type {Array}
 * Course model fields
 */

Tine.Courses.Model.CourseArray = Tine.Tinebase.Model.genericFields.concat([{
  name: 'id'
}, {
  name: 'group_id'
}, {
  name: 'name'
}, {
  name: 'type'
}, {
  name: 'internet'
}, {
  name: 'fileserver'
}, // group fields
{
  name: 'description'
}, {
  name: 'members'
}, // tine 2.0 notes + tags
{
  name: 'notes'
}, {
  name: 'tags'
}, {
  name: 'attachments',
  omitDuplicateResolving: true
}]);
/**
 * @type {Tine.Tinebase.Course}
 * record definition
 */

Tine.Courses.Model.Course = Tine.Tinebase.data.Record.create(Tine.Courses.Model.CourseArray, {
  appName: 'Courses',
  modelName: 'Course',
  idProperty: 'id',
  titleProperty: 'name',
  // ngettext('Course', 'Courses', n);
  recordName: 'Course',
  recordsName: 'Courses'
});

Tine.Courses.Model.Course.getDefaultData = function () {
  return {
    type: Tine.Courses.registry.get('defaultType')
  };
};
/**
 * get filtermodel of course model
 * 
 * @namespace Tine.Courses.Model
 * @static
 * @return {Array} filterModel definition
 * 
 * TODO only add internet access filter if internet_group config is available
 */


Tine.Courses.Model.Course.getFilterModel = function () {
  var app = Tine.Tinebase.appMgr.get('Courses');
  return [{
    label: i18n._('Quick Search'),
    field: 'query',
    operators: ['contains']
  }, {
    label: app.i18n._('Name'),
    field: 'name'
  }, {
    label: app.i18n._('Internet Access'),
    field: 'internet',
    filtertype: 'tine.widget.keyfield.filter',
    app: app,
    keyfieldName: 'internetAccess',
    defaultOperator: 'in'
  }, {
    filtertype: 'foreignrecord',
    app: app,
    foreignRecordClass: Tine.Tinebase.Model.Department,
    ownField: 'type',
    operators: ['equals']
  }];
};
/**
 * @type {Array}
 * Coursetype model fields
 */


Tine.Courses.Model.CourseTypeArray = [{
  name: 'id'
}, {
  name: 'name'
}];
/**
 * @type {Tine.Tinebase.CourseType}
 * record definition
 */

Tine.Courses.Model.CourseType = Tine.Tinebase.data.Record.create(Tine.Courses.Model.CourseTypeArray, {
  appName: 'Courses',
  modelName: 'CourseType',
  idProperty: 'id',
  titleProperty: 'name',
  // ngettext('Course Type', 'Course Types', n);
  recordName: 'Course Type',
  recordsName: 'Courses Types'
});

/***/ }),

/***/ 1858:
/***/ (function(module, exports) {

/**
 * Tine 2.0
 * 
 * @package     Courses
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schuele <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2007-2010 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 */
Ext.namespace('Tine.Courses');
Tine.Courses.MainScreen = Ext.extend(Tine.widgets.MainScreen, {
  activeContentType: 'Course',
  contentTypes: [{
    modelName: 'Course',
    requiredRight: null,
    singularContainerMode: true
  }]
});

Tine.Courses.CourseFilterPanel = function (config) {
  Ext.apply(this, config);
  Tine.Courses.CourseFilterPanel.superclass.constructor.call(this);
};

Ext.extend(Tine.Courses.CourseFilterPanel, Tine.widgets.persistentfilter.PickerPanel, {
  filter: [{
    field: 'model',
    operator: 'equals',
    value: 'Courses_Model_CourseFilter'
  }]
});
/**
 * default backend
 */

Tine.Courses.coursesBackend = new Tine.Tinebase.data.RecordProxy({
  appName: 'Courses',
  modelName: 'Course',
  recordClass: Tine.Courses.Model.Course,

  /**
   * deletes multiple records identified by their ids
   * 
   * @param   {Array} records Array of records or ids
   * @param   {Object} options
   * @return  {Number} Ext.Ajax transaction id
   * @success 
   */
  deleteRecords: function deleteRecords(records, options) {
    options = options || {};
    options.params = options.params || {};
    options.params.method = this.appName + '.delete' + this.modelName + 's';
    options.params.ids = this.getRecordIds(records); // increase timeout to 20 minutes

    options.timeout = 1200000;
    return this.doXHTTPRequest(options);
  }
});
/**
 * default backend
 */

Tine.Courses.courseTypeBackend = new Tine.Tinebase.data.RecordProxy({
  appName: 'Courses',
  modelName: 'CourseType',
  recordClass: Tine.Courses.Model.CourseType
});

/***/ }),

/***/ 1859:
/***/ (function(module, exports) {

/**
 * Tine 2.0
 * 
 * @package     Courses
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2007-2012 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 */
Ext.namespace('Tine.Courses');
/**
 * Course grid panel
 */

Tine.Courses.CourseGridPanel = Ext.extend(Tine.widgets.grid.GridPanel, {
  // model generics
  recordClass: Tine.Courses.Model.Course,
  evalGrants: false,
  // grid specific
  defaultSortInfo: {
    field: 'name',
    direction: 'ASC'
  },
  gridConfig: {
    autoExpandColumn: 'name'
  },

  /**
   * init Tine.Courses.CourseGridPanel
   */
  initComponent: function initComponent() {
    this.recordProxy = Tine.Courses.coursesBackend;
    this.gridConfig.columns = this.getColumns();
    Tine.Courses.CourseGridPanel.superclass.initComponent.call(this);
  },

  /**
   * returns cm
   */
  getColumns: function getColumns() {
    return [{
      id: 'name',
      header: this.app.i18n._("Name"),
      width: 200,
      sortable: true,
      dataIndex: 'name'
    }, {
      id: 'type',
      header: this.app.i18n._("Type"),
      width: 150,
      sortable: true,
      dataIndex: 'type',
      renderer: this.courseTypeRenderer
    }];
  },

  /**
   * course type renderer
   * 
   * @param {} value
   * @return {}
   */
  courseTypeRenderer: function courseTypeRenderer(value) {
    return value.name;
  },

  /**
   * update access of course(s)
   * 
   * @param {Ext.Action} button
   * @param {} event
   */
  updateAccessHandler: function updateAccessHandler(button, event) {
    var courses = this.grid.getSelectionModel().getSelections();
    var toUpdateIds = [];

    for (var i = 0; i < courses.length; ++i) {
      toUpdateIds.push(courses[i].data.id);
    }

    Ext.Ajax.request({
      params: {
        method: 'Courses.updateAccess',
        ids: toUpdateIds,
        type: button.type,
        access: button.access
      },
      success: function success(_result, _request) {
        this.store.load();
      },
      failure: function failure(result, request) {
        Ext.MessageBox.alert(this.app.i18n._('Failed'), this.app.i18n._('Some error occured while trying to update the courses.'));
      },
      scope: this
    });
  }
});

/***/ }),

/***/ 1860:
/***/ (function(module, exports) {

/**
 * Tine 2.0
 * 
 * @package     Tine
 * @subpackage  Widgets
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2012 Metaways Infosystems GmbH (http://www.metaways.de)
 * 
 */
Ext.namespace('Tine.Courses');
/**
 * Generic 'Credentials' dialog
 * 
 * @namespace   Tine.widgets.dialog
 * @class       Tine.Courses.AddMemberDialog
 * @extends     Tine.widgets.dialog.EditDialog
 * @constructor
 * @param       {Object} config The configuration options.
 */

Tine.Courses.AddMemberDialog = Ext.extend(Tine.widgets.dialog.EditDialog, {
  /**
   * @private
   */
  windowNamePrefix: 'AddMemberWindow_',
  loadRecord: false,
  tbarItems: [],
  evalGrants: false,
  mode: 'local',
  recordClass: Tine.Tinebase.Model.Account,

  /**
   * needed for request
   */
  courseData: null,

  /**
   * returns dialog
   */
  getFormItems: function getFormItems() {
    return {
      bodyStyle: 'padding:5px;',
      buttonAlign: 'right',
      labelAlign: 'top',
      border: false,
      layout: 'form',
      defaults: {
        xtype: 'textfield',
        anchor: '90%',
        listeners: {
          scope: this,
          specialkey: function specialkey(field, event) {
            if (event.getKey() == event.ENTER) {
              this.onApplyChanges();
            }
          }
        }
      },
      items: [{
        fieldLabel: this.app.i18n._('First Name'),
        name: 'accountFirstName',
        allowBlank: false
      }, {
        fieldLabel: this.app.i18n._('Last Name'),
        name: 'accountLastName',
        allowBlank: false
      }]
    };
  },

  /**
   * executed after record got updated from proxy
   * 
   * @private
   */
  onRecordLoad: function onRecordLoad() {
    // interrupt process flow till dialog is rendered
    if (!this.rendered) {
      this.onRecordLoad.defer(250, this);
      return;
    }

    var title = this.windowTitle || this.app.i18n._('Add new member to course');

    this.window.setTitle(title);
    this.getForm().loadRecord(this.record);
    this.hideLoadMask();
    this.getForm().findField('accountFirstName').focus(true, 100);
  },

  /**
   * generic apply changes handler
   */
  onApplyChanges: function onApplyChanges() {
    this.onRecordUpdate();

    if (this.isValid()) {
      this.loadMask.show();
      Tine.Courses.addNewMember({
        accountFirstName: this.getForm().findField('accountFirstName').getValue(),
        accountLastName: this.getForm().findField('accountLastName').getValue()
      }, this.courseData, function (response, exception) {
        Tine.log.debug('Tine.Courses.CourseEditDialog::onMembersImport');
        Tine.log.debug(arguments);
        this.hideLoadMask();

        if (response) {
          this.fireEvent('update', response);
          this.window.close();
        } else {
          Tine.Tinebase.ExceptionHandler.handleRequestException(exception.error ? exception.error : exception);
        }
      }, this);
    } else {
      Ext.MessageBox.alert(i18n._('Errors'), i18n._('Please fix the errors noted.'));
    }
  }
});
/**
 * credentials dialog popup / window
 */

Tine.Courses.AddMemberDialog.openWindow = function (config) {
  var window = Tine.WindowFactory.getWindow({
    width: 260,
    height: 160,
    name: Tine.Courses.AddMemberDialog.windowNamePrefix + Ext.id(),
    contentPanelConstructor: 'Tine.Courses.AddMemberDialog',
    contentPanelConstructorConfig: config,
    modal: true
  });
  return window;
};

/***/ }),

/***/ 1861:
/***/ (function(module, exports) {

/**
 * Tine 2.0
 * 
 * @package     Courses
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiss <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2007-2012 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 */
Ext.namespace('Tine.Courses');
Tine.Courses.CourseEditDialog = Ext.extend(Tine.widgets.dialog.EditDialog, {
  /**
   * @private
   */
  windowNamePrefix: 'CourseEditWindow_',
  appName: 'Courses',
  recordClass: Tine.Courses.Model.Course,
  recordProxy: Tine.Courses.coursesBackend,
  evalGrants: false,
  displayNotes: true,
  additionalGroups: [],

  /**
   * initComponent
   */
  initComponent: function initComponent() {
    this.app = Tine.Tinebase.appMgr.get('Courses');
    this.additionalGroups = Tine.Courses.registry.get('additionalGroupMemberships');
    this.initTbarActions();
    Tine.Courses.CourseEditDialog.superclass.initComponent.call(this);
  },
  initTbarActions: function initTbarActions() {
    this.action_import = new Ext.Action({
      iconCls: 'action_import',
      disabled: true,
      text: this.app.i18n._('Import course members'),
      plugins: [new Ext.ux.file.BrowsePlugin({})],
      scope: this,
      handler: this.onFileSelect
    });
    this.action_addNewMember = new Ext.Action({
      iconCls: 'action_add',
      disabled: true,
      text: this.app.i18n._('Add new member'),
      scope: this,
      handler: this.onAddNewMember
    });
    this.tbarItems = [this.action_import, this.action_addNewMember];
  },

  /**
   * onFileSelect
   * 
   * @param {} fileSelector
   * 
   * TODO wrap this into a uploadAction widget
   */
  onFileSelect: function onFileSelect(fileSelector) {
    const files = fileSelector.getFileList();
    this.loadMask.show();
    let upload = new Ext.ux.file.Upload({
      file: files[0],
      fileSelector: fileSelector,
      id: Tine.Tinebase.uploadManager.generateUploadId()
    });
    upload.on('uploadcomplete', function (uploader, record) {
      const tempFile = record.get('tempFile');
      Ext.Ajax.request({
        scope: this,
        timeout: 1200000,
        // 20 minutes
        params: {
          method: 'Courses.importMembers',
          tempFileId: tempFile.id,
          groupId: this.record.data.group_id,
          courseId: this.record.data.id
        },
        success: () => {
          this.loadRemoteRecord();
        },
        failure: function failure() {}
      });
    }, this);
    upload.on('uploadfailure', function (uploader, record) {}, this);
    this.loadMask.show();
    upload.upload();
  },

  /**
   * onAddNewMember
   */
  onAddNewMember: function onAddNewMember(fileSelector) {
    Tine.Courses.AddMemberDialog.openWindow({
      courseData: this.record.data,
      app: this.app,
      listeners: {
        scope: this,
        'update': this.onMembersImport
      }
    });
  },

  /**
   * update members grid
   */
  onMembersImport: function onMembersImport(response) {
    Tine.log.debug('Tine.Courses.CourseEditDialog::onMembersImport');
    Tine.log.debug(response);
    var members = response.responseText ? Ext.util.JSON.decode(response.responseText) : response;

    if (members.results.length > 0) {
      this.loadMembersIntoStore(members.results);
    }

    this.hideLoadMask();
  },

  /**
   * overwrite update toolbars function (we don't have record members yet)
   */
  updateToolbars: function updateToolbars() {},

  /**
   * load members into members store / handle additional groups
   *
   * @param Array members
   */
  loadMembersIntoStore: function loadMembersIntoStore(members) {
    if (members.length > 0) {
      _.each(members, function (member) {
        _.each(member.additionalGroups, function (groupId) {
          member['group_' + groupId] = true;
        });
      });

      this.membersStore.loadData({
        results: members
      });
    }
  },

  /**
   * onRecordLoad
   */
  onRecordLoad: function onRecordLoad() {
    let members = this.record.get('members') || [];
    this.loadMembersIntoStore(members); // only activate import and ok buttons if editing existing course / user has the appropriate right

    var disabled = !this.record.get('id') || !Tine.Tinebase.common.hasRight('manage', 'Admin', 'accounts') || !Tine.Tinebase.common.hasRight('add_new_user', 'Courses');
    this.action_import.setDisabled(disabled);
    this.action_addNewMember.setDisabled(disabled);
    this.action_saveAndClose.setDisabled(!Tine.Tinebase.common.hasRight('manage', 'Admin', 'accounts'));
    Tine.Courses.CourseEditDialog.superclass.onRecordLoad.call(this);
  },

  /**
   * onRecordUpdate
   */
  onRecordUpdate: function onRecordUpdate() {
    Tine.Courses.CourseEditDialog.superclass.onRecordUpdate.call(this);
    let members = [];
    let me = this;
    this.membersStore.each(function (_record) {
      let additionalGroupMemberships = [];

      _.each(me.additionalGroups, function (group) {
        if (_record.get('group_' + group.id)) {
          additionalGroupMemberships.push(group.id);
        }
      });

      _record.set('additionalGroups', additionalGroupMemberships);

      members.push(_record.data);
    });
    this.record.set('members', members);
  },

  /**
   * returns dialog
   * 
   * NOTE: when this method gets called, all initalisation is done.
   */
  getFormItems: function getFormItems() {
    var internetAccessDeactivated = !Tine.Courses.registry.get('config').internet_group || Tine.Courses.registry.get('config').internet_group.value === null;
    return {
      xtype: 'tabpanel',
      plain: true,
      plugins: [{
        ptype: 'ux.tabpanelkeyplugin'
      }],
      defaults: {
        hideMode: 'offsets'
      },
      activeTab: 0,
      border: false,
      items: [{
        title: this.app.i18n.ngettext('Course', 'Courses', 1),
        autoScroll: true,
        border: false,
        frame: true,
        layout: 'border',
        items: [{
          region: 'center',
          xtype: 'columnform',
          labelAlign: 'top',
          formDefaults: {
            xtype: 'textfield',
            anchor: '100%',
            labelSeparator: '',
            columnWidth: 1
          },
          items: [[{
            fieldLabel: this.app.i18n._('Course Name'),
            name: 'name',
            allowBlank: false
          }, {
            xtype: 'reccombo',
            name: 'type',
            allowBlank: false,
            fieldLabel: this.app.i18n._('Course / School Type'),
            displayField: 'name',
            store: new Ext.data.Store({
              fields: Tine.Courses.Model.CourseType,
              proxy: Tine.Courses.courseTypeBackend,
              reader: Tine.Courses.courseTypeBackend.getReader(),
              sortInfo: {
                field: 'name',
                direction: 'ASC'
              }
            })
          }, {
            name: 'description',
            fieldLabel: this.app.i18n._('Description'),
            grow: false,
            preventScrollbars: false,
            xtype: 'textarea',
            height: 60
          }, new Tine.Tinebase.widgets.keyfield.ComboBox({
            fieldLabel: this.app.i18n._('Internet Access'),
            app: 'Courses',
            keyFieldName: 'internetAccess',
            value: 'FILTERED',
            name: 'internet',
            hideLabel: internetAccessDeactivated,
            hidden: internetAccessDeactivated
          })]]
        }, {
          // activities and tags
          layout: 'ux.multiaccordion',
          animate: true,
          region: 'east',
          width: 210,
          split: true,
          collapsible: true,
          collapseMode: 'mini',
          header: false,
          margins: '0 5 0 5',
          border: true,
          items: [new Tine.widgets.tags.TagPanel({
            app: 'Courses',
            border: false,
            bodyStyle: 'border:1px solid #B5B8C8;'
          })]
        }]
      }, {
        title: this.app.i18n._('Members'),
        layout: 'fit',
        items: [this.getMembersGrid()]
      }, new Tine.widgets.activities.ActivitiesTabPanel({
        app: this.appName,
        record_id: this.record.id,
        record_model: this.appName + '_Model_' + this.recordClass.getMeta('modelName')
      })]
    };
  },

  /**
   * get the members grid panel
   * 
   * @return {GridPanel} membersGrid
   */
  getMembersGrid: function getMembersGrid() {
    if (!this.membersGrid) {
      let me = this;
      let membersFields = [{
        name: 'id'
      }, {
        name: 'type'
      }, {
        name: 'name'
      }, {
        name: 'additionalGroups'
      }, {
        name: 'data'
      }];
      let columns = [{
        id: 'data',
        header: this.app.i18n._("Login"),
        width: 200,
        dataIndex: 'data',
        renderer: function renderer(value) {
          return value.account_id ? i18n._('unknown') : value;
        }
      }]; // add configured groups here (as checkbox column) and additionalGroupMemberships fields to store model

      _.each(this.additionalGroups, function (group) {
        let fieldName = 'group_' + group.id;
        columns.push(new Ext.ux.grid.CheckColumn({
          id: fieldName,
          header: group.name,
          width: 100,
          dataIndex: fieldName,
          readOnly: !Tine.Tinebase.common.hasRight('set_additional_memberships', 'Courses', '')
        }));
        membersFields.push(fieldName);
      });

      this.membersStore = new Ext.data.JsonStore({
        root: 'results',
        totalProperty: 'totalcount',
        id: 'id',
        fields: membersFields
      });
      const action_resetPwd = new Ext.Action({
        text: this.app.i18n._('Reset Password'),
        scope: this,
        handler: this.onResetPassword,
        iconCls: 'action_password'
      });
      this.membersGrid = new Tine.widgets.account.PickerGridPanel({
        store: this.membersStore,
        contextMenuItems: [action_resetPwd],
        configColumns: columns,
        enableTbar: Tine.Tinebase.common.hasRight('add_existing_user', 'Courses')
      });
    }

    return this.membersGrid;
  },

  onResetPassword() {
    const passwordDialog = new Tine.Tinebase.widgets.dialog.PasswordDialog({
      allowEmptyPassword: false,
      locked: false,
      questionText: i18n._('Please enter the new Password.'),
      policyConfig: Tine.Tinebase.configManager.get('userPwPolicy')
    });
    passwordDialog.openWindow();
    passwordDialog.on('apply', function (password) {
      this.loadMask.show();
      const accountObject = this.membersGrid.getSelectionModel().getSelected().data;
      Tine.Courses.resetPassword(accountObject.id, password, true).finally(() => {
        this.hideLoadMask();
      });
    }, this);
  }

});
/**
 * Courses Edit Popup
 */

Tine.Courses.CourseEditDialog.openWindow = function (config) {
  var id = config.record && config.record.id ? config.record.id : 0;
  var window = Tine.WindowFactory.getWindow({
    width: 800,
    height: 470,
    name: Tine.Courses.CourseEditDialog.prototype.windowNamePrefix + id,
    contentPanelConstructor: 'Tine.Courses.CourseEditDialog',
    contentPanelConstructorConfig: config
  });
  return window;
};

/***/ }),

/***/ 1862:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1863);
if(typeof content === 'string') content = [[module.i, content, '']];
// Prepare cssTransformation
var transform;

var options = {"hmr":true}
options.transform = transform
// add the styles to the DOM
var update = __webpack_require__(17)(content, options);
if(content.locals) module.exports = content.locals;
// Hot Module Replacement
if(false) {}

/***/ }),

/***/ 1863:
/***/ (function(module, exports, __webpack_require__) {

var escape = __webpack_require__(108);
exports = module.exports = __webpack_require__(16)(false);
// imports


// module
exports.push([module.i, "/**\n * Tine 2.0\n * \n * @package     Courses\n * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3\n * @author      Philipp Schuele <p.schuele@metaways.de>\n * @copyright   Copyright (c) 2007-2009 Metaways Infosystems GmbH (http://www.metaways.de)\n *\n */\n \n.CoursesCourse, .CoursesIconCls {\n    background-image:url(" + escape(__webpack_require__(1864)) + ") !important;\n}\n", ""]);

// exports


/***/ }),

/***/ 1864:
/***/ (function(module, exports) {

module.exports = "\"data:image/svg+xml,%3C?xml version='1.0' encoding='utf-8'?%3E %3C!-- Generator: Adobe Illustrator 21.1.0, SVG Export Plug-In . SVG Version: 6.00 Build 0) --%3E %3Csvg version='1.1' id='Ebene_1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' viewBox='0 0 42.5 42.5' style='enable-background:new 0 0 42.5 42.5;' xml:space='preserve' width='42.5' height='42.5'%3E %3Cpath d='M31.3,20.3l0.3,5c0,0.7-0.4,1.4-1.3,2c-0.9,0.6-2.2,1.1-3.8,1.5c-1.6,0.4-3.3,0.6-5.2,0.6c-1.9,0-3.6-0.2-5.2-0.6 s-2.8-0.9-3.8-1.5c-0.9-0.6-1.4-1.3-1.3-2l0.3-5l9.2,2.9c0.2,0.1,0.5,0.1,0.8,0.1c0.3,0,0.5,0,0.8-0.1L31.3,20.3z M39.8,15.1 c0,0.2-0.1,0.4-0.4,0.5l-17.9,5.6c0,0-0.1,0-0.2,0c-0.1,0-0.1,0-0.2,0L10.8,18c-0.5,0.4-0.8,1-1.1,1.8c-0.3,0.8-0.5,1.8-0.5,2.9 c0.7,0.4,1,1,1,1.7c0,0.7-0.3,1.3-0.9,1.7l0.9,6.9c0,0.1,0,0.3-0.1,0.4c-0.1,0.1-0.2,0.2-0.4,0.2H6.6c-0.2,0-0.3-0.1-0.4-0.2 C6.1,33.2,6,33.1,6.1,33L7,26c-0.6-0.4-0.9-1-0.9-1.7c0-0.8,0.3-1.4,1-1.8c0.1-2.2,0.6-4,1.6-5.3l-5.3-1.7C3.1,15.5,3,15.4,3,15.1 c0-0.2,0.1-0.4,0.4-0.5L21.2,9c0,0,0.1,0,0.2,0c0.1,0,0.1,0,0.2,0l17.9,5.6C39.7,14.7,39.8,14.9,39.8,15.1z'/%3E %3C/svg%3E\""

/***/ }),

/***/ 40:
/***/ (function(module, exports) {


/**
 * When source maps are enabled, `style-loader` uses a link element with a data-uri to
 * embed the css on the page. This breaks all relative urls because now they are relative to a
 * bundle instead of the current page.
 *
 * One solution is to only use full urls, but that may be impossible.
 *
 * Instead, this function "fixes" the relative urls to be absolute according to the current page location.
 *
 * A rudimentary test suite is located at `test/fixUrls.js` and can be run via the `npm test` command.
 *
 */

module.exports = function (css) {
  // get current location
  var location = typeof window !== "undefined" && window.location;

  if (!location) {
    throw new Error("fixUrls requires window.location");
  }

	// blank or null?
	if (!css || typeof css !== "string") {
	  return css;
  }

  var baseUrl = location.protocol + "//" + location.host;
  var currentDir = baseUrl + location.pathname.replace(/\/[^\/]*$/, "/");

	// convert each url(...)
	/*
	This regular expression is just a way to recursively match brackets within
	a string.

	 /url\s*\(  = Match on the word "url" with any whitespace after it and then a parens
	   (  = Start a capturing group
	     (?:  = Start a non-capturing group
	         [^)(]  = Match anything that isn't a parentheses
	         |  = OR
	         \(  = Match a start parentheses
	             (?:  = Start another non-capturing groups
	                 [^)(]+  = Match anything that isn't a parentheses
	                 |  = OR
	                 \(  = Match a start parentheses
	                     [^)(]*  = Match anything that isn't a parentheses
	                 \)  = Match a end parentheses
	             )  = End Group
              *\) = Match anything and then a close parens
          )  = Close non-capturing group
          *  = Match anything
       )  = Close capturing group
	 \)  = Match a close parens

	 /gi  = Get all matches, not the first.  Be case insensitive.
	 */
	var fixedCss = css.replace(/url\s*\(((?:[^)(]|\((?:[^)(]+|\([^)(]*\))*\))*)\)/gi, function(fullMatch, origUrl) {
		// strip quotes (if they exist)
		var unquotedOrigUrl = origUrl
			.trim()
			.replace(/^"(.*)"$/, function(o, $1){ return $1; })
			.replace(/^'(.*)'$/, function(o, $1){ return $1; });

		// already a full url? no change
		if (/^(#|data:|http:\/\/|https:\/\/|file:\/\/\/)/i.test(unquotedOrigUrl)) {
		  return fullMatch;
		}

		// convert the url to a full url
		var newUrl;

		if (unquotedOrigUrl.indexOf("//") === 0) {
		  	//TODO: should we add protocol?
			newUrl = unquotedOrigUrl;
		} else if (unquotedOrigUrl.indexOf("/") === 0) {
			// path should be relative to the base url
			newUrl = baseUrl + unquotedOrigUrl; // already starts with '/'
		} else {
			// path should be relative to current directory
			newUrl = currentDir + unquotedOrigUrl.replace(/^\.\//, ""); // Strip leading './'
		}

		// send back the fixed url(...)
		return "url(" + JSON.stringify(newUrl) + ")";
	});

	// send back the fixed css
	return fixedCss;
};


/***/ }),

/***/ 54:
/***/ (function(module, exports, __webpack_require__) {

/* pkg: Courses FAT Client (js/Courses-FAT.js)*/
__webpack_require__(1857);
__webpack_require__(1858);
__webpack_require__(1859);
__webpack_require__(1860);
__webpack_require__(1861);
/* pkg: Courses FAT Client (css/Courses-FAT.css)*/
__webpack_require__(1862);


/***/ })

}]);